package MCS::CGI::Ecard;

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK $debug);

use POSIX;
use MCS::CGI::Conf;

require Exporter;
require AutoLoader;

@ISA = qw(Exporter AutoLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw(
	
);

@EXPORT_OK = qw(
  send_an_ecard
);


$VERSION = sprintf "%d.%02d", (q$Revision: 1.1 $ =~ /\d+/g);


# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

MCS::CGI::Ecard - Modul fuer das Ecard Skript

=head1 VERSION

$Id: Ecard.pm,v 1.1 2000/12/05 13:07:31 nico Exp $


=head1 SYNOPSIS

  #!/usr/bin/perl -wT
  
  use strict;
  $ENV{PATH} = '/bin:/usr/bin'; # Fuer Taint-Checking
  use MCS::CGI::Ecard qw(send_an_ecard) ;
  use CGI;

  my $cgi = new CGI;
  send_an_ecard( $cgi );


=head1 DESCRIPTION

MCS::CGI::Ecard dient dem Versand von Ecards, die in verschiedene Universal-Sites integriert sind.


=cut



=head1 FUNCTIONS

=over

=item send_an_ecard( $cgi )

Funktionsaufruf um den Versand zu initialisieren.

=cut 

sub send_an_ecard {

    my $cgi = shift;
    print $cgi->header() if($debug);
    unless ($ENV{PATH_INFO} ){
	#set default PATH_INFO
	$ENV{PATH_INFO} = "/ecard/ecard.conf";
	$ENV{PATH_TRANSLATED} = $ENV{DOCUMENT_ROOT}. $ENV{PATH_INFO};
    }
    my $cfg = new MCS::CGI::Conf;

    #########################################################
    #perl path richtig?                                     #
    #send-a-message.pl by c-one communications from r.prehn #
    #dieses script verschickt emails per html-form          #
    #getriggert.                                            #
    #verschickt werden per select-menue ausgewaehlte        #
    #links auf audio-daten.                                 #
    #die pers. daten der verschickenden und empfangenden    #
    #nutzer werden soweit erhaeltlich mitgespeichert.       #
    #########################################################


    ###############################
    #variablen / standards        #
    ###############################
    #was is'n heut fuern tach?
    my $date = format_date_string($cfg->val('ecard','date_format'));
    
    my ($name, $email, $emailTo, $betreff, $cardnr, $message,
	$hidden_message_1, $hidden_message_2, $hidden_message_3);
		
    my ($error_string);

    # wie heisst das logfile fuer die namen und email-adressen?
    my $logfile = $cfg->val('ecard','log_file');


    # name des html formulars
    my $html_form =  $cfg->val('ecard','html_form');

    # name der html fehlerseite
    my $html_error = $cfg->val('ecard','html_error');

    # name der html seite fuer verschicken ok
    my $html_ok =  $cfg->val('ecard','html_thanks');

    # name der html seite fuer fehler im script
    my $html_script_error = $cfg->val('ecard','html_thanks');

    $name = $cgi->param('name') || "no_name_is_given";
    $email = $cgi->param('email') || undef;
    $emailTo = $cgi->param('emailTo') || undef;
    $betreff = $cgi->param('betreff') || "no_betreff_is_given";
    $cardnr = $cgi->param('cardnr') || "no_card_is_given";;
    $message = &trenn($cgi->param('message'));
    $hidden_message_1 = &trenn($cgi->param('hidden_message_1') );
    $hidden_message_2 = &trenn($cgi->param('hidden_message_2') );
    $hidden_message_3 = &trenn($cgi->param('hidden_message_3') );

    $error_string = test_cgi_values($cgi, $cfg);

    if( $error_string ){
	print $cgi->redirect("${html_error}?cardnr=$cardnr&error=" . $error_string);
	exit(0);
    }

    #logfile schreiben
    write_logfile( $ENV{DOCUMENT_ROOT}.$logfile, 
		   [$date,$name,$email,$emailTo,$betreff,$cardnr]);

    #mail verschicken
    &send_mail($cfg, $name,$email,$emailTo,$betreff,$cardnr,$message,$hidden_message_1,$hidden_message_2,$hidden_message_3);
    
    #auf ok-seite redirecten
    print $cgi->redirect("$html_ok?cardnr=$cardnr");
}						


=item sendmail ($cfg, $name, $email, $emailTo, $betreff, $cardnr, $message, $hidden_message_1, $hidden_message_2, $hidden_message_3) 

versendet die Nachricht an den Empfaenger, wobeid die Reply-to-Adresse 
auf die Adresse des angegebenen Absenders ($email) gesetzt wird.
 

=cut

##############################
#send_mail                   #
##############################
sub send_mail {
    my ($cfg, $name,$email,$emailTo,$betreff,$cardnr,$message,$hidden_message_1,$hidden_message_2,$hidden_message_3) = @_;
    my $your_ecard = $cfg->val('ecard','your_ecard');
    unless( $your_ecard =~ /$ENV{SERVER_NAME}/ ){
	$your_ecard = $ENV{SERVER_NAME} . $your_ecard;
    }
    my $link = "${your_ecard}?cardnr=$cardnr";
    my $server_protocoll = $cfg->val('ecard','server_protocoll') || "http";
    my $bild = "<a href=\"$server_protocoll://$link\"><img src=\"$server_protocoll://";
	$bild .= $ENV{SERVER_NAME} . $cfg->val('ecard','pic_dir');
	$bild .= "ecard".$cardnr;
	$bild .=  $cfg->val('ecard','bigpic') ."\"></a>";

    #html-ify message.
    $message =~ s/\n/<br>\n/g;

    $hidden_message_1 ||= "";
    $hidden_message_2 ||= "";
    $hidden_message_3 ||= "";
        # Check the sendmail command for security
    my $sendmail = $cfg->val('mail', 'sendmail');
    die
	"$sendmail insecure (must be an absolute path without whitespace)\n"
	    unless $sendmail =~ m|^/[^\s]+$|;
    die "$sendmail not found or not executable.\n"
	unless -x $sendmail;
    open SENDMAIL, "| $sendmail -t -oi"
        or die "Cannot open sendmail: $!\n";

    print SENDMAIL "From: " . ($cfg->val('ecard','from') || $ENV{SERVER_ADMIN}) . "\n";	
    print SENDMAIL "To: $emailTo\n";
    print SENDMAIL "Subject: $betreff\n";
    print SENDMAIL "Reply-to: $email\n";
    
    print SENDMAIL <<EOF;
Content-Type: text/html; charset=us-ascii
Content-Transfer-Encoding: 7bit

$hidden_message_1 

$message


$hidden_message_2
<p align="center">
$bild
</p>
$hidden_message_3 $server_protocoll://$link


EOF

	close (SENDMAIL);
}

=item write_logfile ($logfile, \@arr ) 

schreibt eintraege in ein Logfile

=cut

##############################
#logfile schreiben           #
##############################
sub write_logfile {
    my ($logfile, $arr_ref ) = @_;
    my @arr = @$arr_ref;
    print STDERR "logfile : $logfile\n" if ($debug);
    if($logfile =~ /^([-_\w.\/]+)$/ ){
	$logfile = $1;

	open (LOG,">>$logfile") || 
	    die print STDERR "Kann logfile $logfile nicht zum schreiben oeffen\n";
	if( flock(LOG, 2) ) {
	    foreach (@arr) {
		print LOG $_."|";
	    }
	    print LOG "\n";
	    flock(LOG, 8);
	}
	else{
	    
	}
	close (LOG);
    }
}


################################################################
#sub fuer zeilen bei 75 zeichn umbrechen, damit in mail lesbar #
################################################################
sub trenn {
    my ($string, $maxlength) = @_;

    unless( $string ){
	return;
    }

    $maxlength ||=75;
    my (@woerter,$meta,$output);
    $meta ="";
    @woerter = split (/\ /,$string);
    foreach (@woerter) {
	if (length($_) + length($meta) <= $maxlength) {
	    $meta .= " " if ($meta);
	    $meta .= $_;
	} else {
	    $output .= $meta . "\n";
			$meta = "$_";
	}
    }
    $output .= $meta;
    $output;
}

=pod

B<format_date_string> gibt einen Datumsstring zurueck.

=cut

sub format_date_string{
    my ($format) = @_;
    return POSIX::strftime( $format, localtime(time));    
}

=item test_cgi_values( $cgi, $cfg)

prE<uuml>ft, ob die Werte sinnvoll und vollstE<auml>ndig sind.
 

=cut

sub test_cgi_values{
    my ($cgi, $cfg) = @_;

    my ($name, $email, $emailTo, $betreff, $cardnr, $message,
	$hidden_message_1, $hidden_message_2, $hidden_message_3);


    $name = $cgi->param('name') || "no_name_is_given";
    $email = $cgi->param('email') || undef;
    $emailTo = $cgi->param('emailTo') || undef;
    $betreff = $cgi->param('betreff') || "no_betreff_is_given";
    $cardnr = $cgi->param('cardnr') || "no_card_is_given";;
    $message = &trenn($cgi->param('message'));


    my $error_string;

    if( !$email || ( $email !~ /[-a-zA-Z]+\@{1}[-a-zA-Z]+\..+/ ) ) {
	$error_string .= $cfg->val('ecard_error','sender_email');
    }
    if( (!$emailTo )|| ( $emailTo !~ /[-a-zA-Z]+\@{1}[-a-zA-Z]+\..+/ ) ) {
	$error_string .= $cfg->val('ecard_error','destination_email');
    }
    if( !$betreff || ( $betreff =~ /\<\>\~/ ) ) {
	$error_string .= $cfg->val('ecard_error','subject');
    }
    if ( !$message || ( $message=~/[\<\>\~]/ ) ) {
	$error_string .= $cfg->val('ecard_error','message');
    }
}




# Preloaded methods go here.

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__

=head1 AUTHOR

 based on "send-a-message.pl by c-one communications from r.prehn"
 Klaus Tillmann <nico@mcs-cityline.net>

=head1 SEE ALSO

perl(1).

=cut
