package MCS::CGI::Sendmail;
#require 5.005_62;

# $Log: Sendmail.pm,v $
# Revision 1.45  2006/05/29 16:00:14  nico
# [UPD] u.a. CTS#53382
#       In der Konfigurationsdatei soll ein from: angegeben werden koennen
#       [EMAIL]
#       from = absender@muster.de
#
# Revision 1.44  2006/02/22 14:42:25  nico
# [UPD] * send_html_mail_by_template
#         auch hier Spam-Prevention nachgeruestet
#
# Revision 1.43  2006/02/20 16:31:35  nico
# [UPD] * send_mail
#         $from wird bereinigt, Keine Zeilenumbrche oder Leerzeichen
#         dadurch sollte SPAM nicht mehr mglich sein
#       * mail_response
#         Funktion gelscht wird nirgends aufgerufen
#
# Revision 1.42  2006/02/14 14:28:12  nico
# [UPs] Klammer vergessen
#
# Revision 1.41  2006/02/14 14:26:08  nico
# [UPD] fr 'EMAIL','format_values_first'
#       wenn fieldname gesetzt aber keine value existiert, wird keine
#       Zeile mit fieldname mehr ausgegeben
#
# Revision 1.40  2006/02/14 12:58:44  nico
# [UPD] kleine Formataenderung
#
# Revision 1.39  2006/02/14 10:54:11  nico
# [UPD] CTS#52059 Erweiterung damit VALUE: Bezeichnung moeglich ist
#
# Revision 1.38  2006/02/03 16:01:34  nico
# [UPD] Kleinen Fehler mit HeaderHandling korregiert
#
# Revision 1.37  2006/02/03 13:27:36  nico
# [UPD] wenn in Konfigurationsdatei
#        [REDIRECT]
#          mailok = /mailok-redirect.php?value=123
#          missing = /missing-redirect.php?value=123
#        definiert ist, wird keine HTML-Datei mehr geladen
#        sondern ein Reidrect ausgeloest.
#
# Revision 1.36  2005/09/06 09:17:08  nico
# [UPD]  wird jetzt per give_valid_email taint checked
#
# Revision 1.35  2005/09/06 08:59:25  nico
# [UPD] sendmail -t -f hier wird nicht mehr die To Addr. genommen,
#       wenn kein return_path in .ini gesetzt wurde.
#       Default ist dann ENV[SERVER_ADMIN]
#
# Revision 1.34  2005/09/02 09:28:48  nico
# [UPD] noch ein paar webmaster@ vorkommen ersetzt
#
# Revision 1.33  2005/09/02 09:18:54  nico
# [UPD] - an allen Stellen webmaster@$ENV{SERVER_NAME} ersetzt
#
# Revision 1.32  2005/09/02 09:08:14  nico
# [UPD] * run_send_mail
#         default $from auf "$ENV{SERVER_ADMIN}" statt
#         "webmaster\@$ENV{SERVER_NAME}" gesetzt
#
# Revision 1.31  2003/12/11 14:10:54  nico
# [FIX] * send_html_mail_by_template
#           Content-Type war nicht vollstndig richtig.
#
# Revision 1.30  2003/12/10 21:05:49  nico
# [UPD] neue Funktionalitaet ergaenzt: Template-eMails konnen jetzt gerniert
#       werden. In Config-File muss dazu folgendes eingetrangen werden
#       [TEMPLATE]
#       mail_template   =       /PFAD-ZUM-TEMPLATE
#
#       [EXTRA_FLAGS]
#       template_mail   = 1
#
# Revision 1.29  2003/03/24 12:06:09  nico
# [UPD] HTML::Template  durch  MCS::CGI::HTML::Template
#       ersetzt
#
# Revision 1.28  2003/03/03 12:59:55  nico
# [UPD] Fehlermeldung, wenn weder PATH_INFO *noch* HTT_REFERER gesetzt sind
#
# Revision 1.27  2002/10/30 14:37:27  nico
# [FIX] * send_mail
#         Spellingmistake: recipent in recipient korregiert
#
# Revision 1.26  2002/03/07 17:20:48  nico
# * [FIX] bcc wurde bisher einfach ignoriert,
#         bei Standard ohne Anhang wird auch Bcc nun ausgewertet
# * [FIX] besseres ErrorHandling bei fehlendem To:
#
# Revision 1.25  2002/03/05 17:18:49  nico
# * [FIX] - replace_placehoders
# 	  nimmt jetzt auch ein Array entgegegen, gibt aber weiterhin
#           nur einen String zurck
#         - kleinere spelling mistakes wie
#           sperator --> seperator
# 	  $ini-val --> $ini->val
#
# Revision 1.24  2002/03/05 16:16:42  nico
# * [NEW] Sendmail brauchte einige Anpassungen fuer Lilly
#         neue Parameter moeglich:
# 	[EMAIL]
# 	* format_key_value_sperator
# 	* format_line_seperator
# 	* format_begin_message
# 	* format_end_message
#
#

$ENV{PATH} = '/bin:/usr/bin';

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK %EXPORT_TAGS $debug);

$debug = 0;

#use warnings;
use MCS::CGI::Conf;
use MCS::CGI::Standard;
use MCS::CGI::HTML::Template;

use CGI qw( :cgi);
use CGI::Carp qw(fatalsToBrowser);
use MIME::Lite;

require Exporter;
use AutoLoader qw(AUTOLOAD);

@ISA = qw(Exporter);

%EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

@EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

@EXPORT = qw(
run_send_mail	
);

#$VERSION =  sprintf "%d.%02d", (q$Revision: 1.45 $ =~ /\d+/g);
$VERSION =  '$Id: Sendmail.pm,v 1.45 2006/05/29 16:00:14 nico Exp $ '; 



=head1 NAME

MCS::CGI::Sendmail - Perl extension for MCS-Cityline Virtual Webservers

=head1 SYNOPSIS

  use MCS::CGI::Sendmail;

=head1 VERSION

	$Id: Sendmail.pm,v 1.45 2006/05/29 16:00:14 nico Exp $
 


=head1 DESCRIPTION

Wird zur Formularauswertung benutzt zum Versenden einer E-Mail.


=head2 EXPORT

None by default.

=cut


#----------------------------------->

#----------------------------------->


sub run_send_mail {
	my (@param_keys,$ini,$mail_ok,$html_ok,$required_ok);
	my $sendmail_path = "/usr/lib/sendmail";

	unless( $ENV{PATH_INFO} ) {
	    if( $ENV{HTTP_REFERER}) {
		set_path_translated_according2referer();
	    }
	    else{
	        print header('text/html');
		print "Sorry, Skript-Aufruf fehlerhaft.<br>Bitte kommen Sie nochmal durch den <a href='http://$ENV{SERVER_NAME}/'>Haupteingang von $ENV{SERVER_NAME}</a>.\n";
		print STDERR "Skript-Aufruf ohne PATH_INFO *und* ohne HTTP_REFERER - wahrscheinlich fehlerhafter Aufruf durch Suchmaschine\n";
		return undef;
	    }
	}
	$ini = new MCS::CGI::Conf;
	

	@param_keys = param;
	
	$required_ok = required_entries_exist ($ini);

	if ($required_ok == 1) {
	    if( $ini->val('EXTRA_FLAGS','file_upload') ){
			print STDERR "\nsend_mail_with_attachment\n\n" if($debug);
			$mail_ok = send_mail_with_attachment($ini,$sendmail_path,@param_keys);
	    }
		elsif($ini->val('EXTRA_FLAGS','template_mail') ){
			$mail_ok = send_html_mail_by_template($ini,$sendmail_path);
		}
	    else{
			print STDERR "\nsend_mail\n\n" if($debug);
			$mail_ok = send_mail($ini,$sendmail_path,@param_keys);
	    }
	}

	if( $ini->val('REDIRECT','mailok') ){
		redirect_response($ini,$required_ok);
	}
	else{
	        print header('text/html');
		$html_ok = html_response ($ini,$required_ok,@param_keys);
		#admin_error("Mail kann nicht versandt werden $! ") ;
	}
}


sub redirect_response {
	my ($ini,$required_ok) = @_;
	if( $required_ok) {
		print CGI::redirect( $ini->val('REDIRECT','mailok') );
	}
	else{
		print CGI::redirect( $ini->val('REDIRECT','missing') );
	}
}


sub required_entries_exist {
	my ($conf) = @_;
	my (@options,$i,$option,$val);
	$i=1;
	$val=1;
	# Iteriere ueber alle Optionsvarianten
	while($option = $conf->val('REQUIRED',"option$i") ){
		$option =~ s/[^a-z-_A-Z0-9]/ /g;
		@options = split /\s+/,$option;
		$val = 1;
		foreach $option ( @options){
			unless(param($option)){
				$val=0;
				next;
	    		}
		}
	
	if ($val){ return 1; }
	$i++;
	}
	return 0;
}


sub spam_clearing {
	my ($email_address) = @_;	
	$email_address =~ s/
/ /gm;
	$email_address =~ s/[:\,\;\s].*//;
	return $email_address;
}

sub send_mail {
	my ($ini,$sendmail_path,@param_keys) = @_;
	my $from = param($ini->val('EMAIL','reply_to')) ||$ini->val('EMAIL','from' ) || "$ENV{SERVER_ADMIN}";
	
	my (@to,$recipient);
	if ($recipient = param('recipient') ) {
		 @to = $ini->val('RECIPIENT',$recipient) or 
		print STDERR ("RECIPIENT $recipient in $ENV{PATH_TRANSLATED} not defined\nKein Mailto angegeben\n");
	}
	else {
		print STDERR "to: ", $ini->val('EMAIL','to'),"\n" if ($debug);
	@to = $ini->val('EMAIL','to') or
		print STDERR ("EMAIL to in $ENV{PATH_TRANSLATED} not defined\nKein Mailto angegeben\n");
	}
	my $reply_to = $ini->val('EMAIL','reply_to') ;
	if( MCS::CGI::Standard::is_valid_email(param($reply_to) )) {
	        $reply_to = param ($reply_to);
        }
	else{
		$reply_to = "";
	}
	my @cc = $ini->val('EMAIL','cc');
	my $bcc = $ini->val('EMAIL','bcc');
	my $confirm_cc = test_for_confirm_cc( $ini );
	if( $confirm_cc) {
	    push (@cc, $confirm_cc);
	}

	my $subject = $ini->val('EMAIL','subject');
	my $return_to = $ini->val('EMAIL','return_path');
		$return_to = "$ENV{SERVER_ADMIN}" unless ($return_to);
		$return_to = MCS::CGI::Standard::give_valid_email($return_to);
		
	my $msg = "";
	
	if ($ini->val('REQUIRED','sortorder')) { # wenn eine sortorder angegeben, nehme sie.
		@param_keys = split /[,; ]+/ , $ini->val('REQUIRED','sortorder');
		}

	my (@output);
	if($ini->val('EMAIL','format_begin_message') ){
	    push (@output, replace_placehoders($ini->val('EMAIL','format_begin_message')) );
	}
	push (@output, format_mail_response($ini,@param_keys));
	if( $ini->val('EMAIL','format_end_message') ){
	    push @output , replace_placehoders($ini->val('EMAIL','format_end_message'));
	}
	unless( $debug){
	open (MAIL, "| $sendmail_path -t -f $return_to") or die "sendmail konnte nicht geoeffnet werden: $!\n";
	}
	else{
	open (MAIL, ">/tmp/send-mail$$") or die "sendmail konnte nicht geoeffnet werden: $!\n";
	}
	unless( @to && $to[0] ne "") {
		print STDERR "No recipient found in \@to @to\n";
		print header();
		admin_error("No valid recipient, Kein gueltiger Empfaenger in configurationsgefunden\n$ENV{PATH_INFO}\n");
	}
	# SPAM Prevention - \nBcc: etc wird weggefilter
	$from =~ s/
/ /gm;
	$from =~ s/[\,\;\s].*//;
	print MAIL "From: $from\n";
	print MAIL "Reply-To: $reply_to\n";
	print MAIL "To:@to\n";
	print MAIL "Cc:@cc\n" if(@cc);
	print MAIL "Bcc:$bcc\n" if($bcc);
	print MAIL "Subject: $subject\n";
	print MAIL "Content-Type: text/plain; charset=\"iso-8859-1\"\n";
 	print MAIL  "\n";
 	foreach (@output) {
		print MAIL $_;
		}
	print MAIL "KEY:$recipient\n" if($debug);
	close MAIL or die "Fehler bei sendmail: $!, $?\n";
	return 1;
}


=item * send_mail_with_attachment 

versendet E-Mail inkl. Attachment

=cut

sub send_mail_with_attachment {
	my ($ini,$sendmail_path,@param_keys) = @_;

	my ($i);
	my $from = param($ini->val('EMAIL','reply_to')) ||$ini->val('EMAIL','from' ) || "$ENV{SERVER_ADMIN}";

	my $to = $ini->val('EMAIL','to') or admin_error("Kein Mailto angegeben");
	my $reply_to = $ini->val('EMAIL','reply_to') ;
	   $reply_to = MCS::CGI::Standard::give_valid_email(param($reply_to) ); 
	my $cc = $ini->val('EMAIL','cc');
	my $bcc = $ini->val('EMAIL','bcc');
	my $confirm_cc = test_for_confirm_cc( $ini );
	if( $confirm_cc) {
	    $cc .= " $confirm_cc";
	}

	my $subject = $ini->val('EMAIL','subject');
	my $return_to = $ini->val('EMAIL','return_path');
		$return_to = "$ENV{SERVER_ADMIN}" unless ($return_to);
		$return_to = MCS::CGI::Standard::give_valid_email($return_to);	

	my $msg = 
	  MIME::Lite->new(
		      From    => $from,
		      To      => $to,
		      Cc      => $cc,
		      Subject => $subject,
		      Type    =>'multipart/mixed'
		      );

	
	if ($ini->val('REQUIRED','sortorder')) { # wenn eine sortorder angegeben, nehme sie.
		@param_keys = split /[,; ]+/ , $ini->val('REQUIRED','sortorder');
		}

	my (@output) = format_mail_response($ini,@param_keys);
	my $text;
	foreach ( @output) {
	    $text .= $_;
	}
	$msg->attach( Type     =>'TEXT',
		      Data     => $text
		      );

	print STDERR "jetzt kommt for-Schleife\n";
	print STDERR "ini ", $ini->val('FIELDNAME',"file_upload0"),"\n";
        print STDERR "param: ", param("file_upload0"),"\n";
	for($i = 0; $i <=9; $i++) {
	    if($ini->val('FIELDNAME',"file_upload${i}") &&
	       param("file_upload${i}") ) {
		print STDERR "\nes muesste in File angehaengt sein\n";
		$msg->attach(Type     => (CGI::uploadInfo(param("file_upload$i"))->{'Content-Type'}),
#		$msg->attach(Type     => "image/gif",
			     FH       => param("file_upload$i"),
			     Filename => param("file_upload${i}"),
			     Disposition => 'attachment'
			     );
	    }
	}

	open (MAIL, "| $sendmail_path -t -f $return_to") or die "sendmail konnte nicht geoeffnet werden: $!\n";
#	open (MAIL, ">/var/tmp/mail$$") or die "sendmail konnte nicht geoeffnet werden: $!\n";

	$msg->print(\*MAIL);
	close MAIL or die "Fehler bei sendmail: $!, $?\n";
	return 1;
}



=item B<test_for_confirm_cc> ($iniconf)

PrE<uuml>ft ob der Parameter confirm_cc in der INI-Datei definiert ist und gibt dann den Wert des im CGI-Objekt gespeicherten Parameter zurueck.
Diese Funktion wird genutzt um CC-Mails u.a. an etwaige Kunden zu senden.


=cut


sub test_for_confirm_cc{
    my $ini = shift;
    my $confirm_cc = $ini->val('EMAIL','confirm_cc') ;
    if( param( $confirm_cc) && MCS::CGI::Standard::is_valid_email(param($confirm_cc) )) {	
	return param($confirm_cc);
	
    }
}



sub format_mail_response {
	my ($ini,@param_keys_in) = @_;
	my $names="";
	my $values="";
	my $db = $ini->val('EMAIL','format_db');
	my $dots = $ini->val('EMAIL','format_dots');
	my ($format,@output,$max_field_length);
	my ($i);
	my %pre;

	my $predefined=1;
	my $pred ; #= map { /PREDEFINED/ ,$_} $ini->LocalSections;
	
	#
	# bereinige @param_keys_in um file_upload0-9
	#
	my @param_keys;
	if($ini->val('EXTRA_FLAGS','file_upload')) {
	    foreach ( @param_keys_in) {
		unless( $_ =~ /^file_upload/) {
		    push( @param_keys, $_);
		}
	    }
	}
	else{
	    @param_keys = @param_keys_in;
	}

	foreach ($ini->LocalSections) {
		$pred = $_ if ($_ eq "PREDEFINED");
	}
	
	#if exists $ini->LocalParameters('PREDEFINED')
	
	if ($pred && ($pred eq "PREDEFINED")) {
	
	if ($ini->LocalParameters('PREDEFINED')) {
		my @predefined =  $ini->LocalParameters('PREDEFINED') if ($pred eq "PREDEFINED");# if ($_ eq 'PREDEFINED') ;

		foreach ($ini->LocalParameters('PREDEFINED') ) {
			$pre{$_} = $ini->val('PREDEFINED',$_);
		}
	}
	
	}
#	if (!$predefined) {
#		# Nur Parameter aus dem QueryString werden ausgegeben,
#		# Ausnahme: unter [PREDEFINED] sind die parameter vorbelegt.		
#	    my $grenze = scalar( @param_keys);
#		for ($i = 0; $i < $grenze; $i++) {
#		    if (!param ($param_keys[$i])) {
#			splice (@param_keys,$i,1) ;
#			$grenze--;
#			$i--;
#		    }
#		}
#	}
	
	# wenn in der Ini angegeben:
	if ($db) {
		$names= join ";",@param_keys;
		foreach (@param_keys) {
			$values .= param ($_) . ";";
		}
		return ($names."\n",$values."\n");
	}
	

	# wenn in der Ini angegeben:
	if ($dots) {
		$max_field_length = $dots;

		foreach (@param_keys) {
			my $param = $_;
			my $value ="";
			my $fieldname = $ini->val('FIELDNAME',$param);
			my $leng = length($fieldname);
			
			$dots = $max_field_length - $leng;
			if($dots>0) {
				$format = "." x $dots;
			}
			else{ 
				$format ="";
			}
			my $name = "$fieldname $format:\t";

			if ($fieldname) {
				my @values = param($param) ;
				if (scalar (@values) <= 0) {
					push @values,$pre{$param};
				}
				
				foreach (@values) {
					$value .= "$_\n";
				}
				push @output,$name.$value;
			}
		}
	
		return (@output);
	}
	
	# Erweiterung fr CTS#52059
	if( $ini->val('EMAIL','format_values_first') ) {
		
			foreach (@param_keys) {
			my $param = $_;
			my $value ="";
			my $fieldname = $ini->val('FIELDNAME',$param);
			
			my $name = "$fieldname";

			my @values = param($param) ;
			if (scalar (@values) <= 0) {
				push @values,$pre{$param};
			}
			foreach (@values) {
				$value .= "$_\t";
			}
			
			if( $fieldname) {
				if( $value =~ /[a-zA-Z0-9]/ ) {
					push @output,"$value\t$name\n";
				}
			}
			else{
				push @output,  "$value\n";
			}		
		}

		return (@output);	
	
	}
	
	
	
	# default output format

	my $key_value_seperator = $ini->val('EMAIL','format_key_value_sperator') || " = ";
	my $line_seperator = $ini->val('EMAIL','format_line_seperator') || "";
	$line_seperator =~ s/\\n/
/g;
	foreach (@param_keys) {
		my $param = $_;
		my $values = "";
		my $fieldname = $ini->val('FIELDNAME',$param) || $param;
		my @values = param($param) || $pre{$param}; #or $ini->val('PREDEFINED',$param);

			foreach (@values) {
				$values .= "$_\n";
			}

		push @output , $fieldname . $key_value_seperator .$values.$line_seperator;
	}
	return @output;
}


sub html_response {
	my ($ini,$required_ok,@param_keys) = @_;
	my ($response,$mailok,$missing);
	
	$mailok = $ini->val('TEMPLATE','mailok');
	$missing = $ini->val('TEMPLATE','missing');

	if ($ini->val('REQUIRED','sortorder')) {
		@param_keys = split /[,; ]+/ , $ini->val('REQUIRED','sortorder'); }

	if ($required_ok) {
		$response = $ENV{DOCUMENT_ROOT}.$mailok;
	} else {
		$response = $ENV{DOCUMENT_ROOT}.$missing;
	}
	
	if (-f $response) {
	    if( $ini->val('TEMPLATE','parse_file') ) {
		my $parse = new MCS::CGI::HTML::Template;

		foreach (@param_keys) {
		    my $tr_param = $_;
		    $tr_param =~ tr/a-z/A-Z/;
		    $parse->var( $tr_param => param($_) || "");
		    $parse->var( "FIELDNAME_${tr_param}" => $ini->val('FIELDNAME', param($_)) || "");
		}
		$parse->parse_file($response);
	    }
	    else{
		open FILE,$response or die "response kann nicht gelesen werden.";
		while (<FILE>) {
			my $line = $_;
			my $input = "<table>";

			foreach (@param_keys) {
				$input .= "<tr><td>".$ini->val('FIELDNAME',$_ )."</td><td>".param($_)."</td></tr>\n";
			}
		
			$input .= "</table>";

			if ($line =~ m/<!--\W\#\#\#\W-->/) {
				$line =~ s/<!--\W\#\#\#\W-->/$input/;
			}
		
			print $line ;
		}
		close FILE;
	    }
	}
	else {
		print "Fehler: $required_ok $mailok oder $missing fehlt\n<br>";	
		print "Vielen Dank, das Formular wurde mit folgenden Angaben abgeschickt:<table>" if ($required_ok);
		print "Nicht alle erforderlichen Felder wurden ausgef&uuml;llt. Die Mail wurde nicht versandt. <p>Klicken Sie hier, um <a href=\"javascript:history.back()\">zur&uuml;ck</a> zu gehen."  if (!$required_ok);
		print "<table>";
		foreach (@param_keys) {
				print "<tr><td>".$ini->val('FIELDNAME',$_ )."</td><td>",param($_),"</td></tr>\n";
		}
		print "</table>";

	}
	return;
}


sub admin_error {
	my @error = ($ENV{SERVER_NAME},$ENV{SCRIPT_NAME},": "," @_" );
	print @error;
	print "<p>Klicken Sie bitte hier, um eine E-Mail an den <a href=\"mailto:$ENV{SERVER_ADMIN}?subject=@error\">webmaster</a> zu senden.";
	exit(0);
}


=item B<set_path_translated_according2referer>()

set_path_translated_according2referer setzt ENV{PATH_TRANSLATED} auf 
DOCUMENT_ROOT + HTTP_REFERER ohne webserver-Part.

=cut

sub set_path_translated_according2referer {

    my ($file);
    $file = $ENV{HTTP_REFERER};
    # $file z.B.: http://SERVER_NAME/my-dir/myfile.html;
    # $file z.B.: http://SERVER_NAME/myfile.html;
    
    #extract path- and filename with out extention from the referer!
    $file =~ s/.*:.*?[^\/](\/.*\.).*/$1/;
    $file = $ENV{DOCUMENT_ROOT}.$file."ini";

    # $file z.B.: /var/customers/my-dir/myfile.html;   
    if( -f $file ) { 
	$ENV{PATH_TRANSLATED} = $file;
	return 1;
    }
    else {
	print STDERR "$ENV{SERVER_NAME}: Keine locale Conf.Datei gefunden\n";
	return undef;
    }
    
}


=item B<replace_placehoders> (@String)

String kann folgende Parameter enthalten die wie folgt ersetzt werden:
 __DATE__ : %d.%m.%Y
 __TIME__ : %H:%M:%s
 __SERVER_NAME__ : $ENV{SERVER_NAME}
 __VERION__ : $id$


=cut

sub replace_placehoders{
    my (@strings ) =  @_;
    my $string;
    foreach( @strings) {
	$string .= $_."\n";
    }
    print STDERR @strings if($debug);
    my ($time, $date);
    my ( $sek, $min, $std, $Mtag, $monat, $jahr, $wtag, $jtag, $isdst ) = localtime(time);
    $monat++;
    $jahr+=1900;
    $date = "$Mtag.$monat.$jahr";
    $time = sprintf "%02d:%02d:%d", $std,$min,$sek;
    $string =~ s/__VERSION__/$VERSION/gs;
    $string =~ s/__DATE__/$date/gs;
    $string =~ s/__TIME__/$time/gs;
    $string =~ s/__SERVER_NAME/$ENV{SERVER_NAME}/gs;
    print STDERR $string if($debug);
    return ($string);
}

=item * send_html_mail_by_template 

generiert eine gestaltete E-Mail anhand des Temlates 
[TEMPLATE]
mail_template = muster.tmpl.html


=cut 

sub send_html_mail_by_template {
    my ($cfg, $sendmail_path) = @_;

    my (@param_keys);
    my $parse = new MCS::CGI::HTML::Template;
    
	my $from = param($cfg->val('EMAIL','reply_to')) || $cfg->val('EMAIL','from' ) || "$ENV{SERVER_ADMIN}";
		
	my $to = $cfg->val('EMAIL','to') or admin_error("Kein Mailto angegeben");
	my $reply_to = $cfg->val('EMAIL','reply_to') ;
	   $reply_to = param ($reply_to) if( MCS::CGI::Standard::is_valid_email(param($reply_to) ))  ; 
	my $cc = $cfg->val('EMAIL','cc');
	my $bcc = $cfg->val('EMAIL','bcc');
	my $confirm_cc = test_for_confirm_cc( $cfg );
	if( $confirm_cc) {
	    $cc .= " $confirm_cc";
	}

	my $return_to = $cfg->val('EMAIL','return_path') || $to;
		$return_to = "$ENV{SERVER_ADMIN}" unless ($return_to);

	# SPAM Prevention - \nBcc: etc wird weggefilter
	$from = spam_clearing($from);
	$to = spam_clearing($to);
	$cc = spam_clearing($cc);
	$bcc = spam_clearing($bcc);
	
	my $subject = $cfg->val('EMAIL','subject') || "email aus Webpraesenz";
		
    my $mail_type =    $cfg->val('EMAIL','mail_mimetype') || "text/html";
    my $charset=       $cfg->val("EMAIL","mail_charset") || "iso-8859-1";
		
	@param_keys = param;
		
	if ($cfg->val('REQUIRED','sortorder')) { # wenn eine sortorder angegeben, nehme sie.
		@param_keys = split /[,; ]+/ , $cfg->val('REQUIRED','sortorder');
	}


    $parse->var(TO => $to|| "");
    $parse->var(FROM => $from || "");
    $parse->var(CC => $cc || "");

	foreach( @param_keys) {
		my $tr_param = $_;
		$tr_param =~ tr/a-z/A-Z/;
		$parse->var( $tr_param => param($_) || "");
	}
		
    my $sendmail = $cfg->val('mail', 'sendmail');
    die
	"$sendmail insecure (must be an absolute path without whitespace)\n"
	    unless $sendmail =~ m|^/[^\s]+$|;
    die "$sendmail not found or not executable.\n"
	unless -x $sendmail;

	open SENDMAIL, "| $sendmail -t "
        or die "Cannot open sendmail: $!\n";

	
    # $msg->print(\*SENDMAIL);
    print SENDMAIL <<EOF;
From: $from
To:   $to
Cc:   $cc
Bcc:  $bcc
Subject: $subject
Mime-Version: 1.0
Content-Type: $mail_type; charset="$charset"

EOF
    my $stdout = select(SENDMAIL);

    $parse->parse_file( $ENV{DOCUMENT_ROOT}.$cfg->val('TEMPLATE','mail_template'));

    select($stdout);
    close (SENDMAIL);

}
1;

__END__


=head1 AUTHOR

Nico Tillmann, Ludger Ester, mcs-cityline.net
devel@mcs.de

=head1 SEE ALSO

perl(1).

=cut
